#ifndef __BZK_PARSINGTOOLS__
# define __BZK_PARSINGTOOLS__
# include <iostream>
# include <fstream>
#include <string>
#include <sstream>
#include <SDL/SDL.h>
using namespace std;

class BZK_ParsingTools
{
 public:

   static
     int
     GetTokenDivider(string Father,string Separator)
       {
	  int pos1=0;

	  while ((Father.substr(pos1,1)!=Separator)&&(pos1!=Father.length())) pos1++;
	  return pos1;
       }

   ///deprecated
   static
     bool
     IsNumeric(std::string *Token)
       {
	  char**endptr=(char**)malloc(1);
	  bool logical;
	  int number=strtol(Token->c_str(),endptr,10);
	  logical=!((!strcmp(Token->c_str(),*endptr))&&(number==0));
	  delete endptr;
	  return logical;
       }

   static
     float
     GetNumber(std::string *Token)
       {
	  float number;
	  std::istringstream ss(*Token);
	  ss >> number;
	  return number;
       }

   static
     float
     GetNumber(std::string Token)
       {
/*
///deprecated
  char**endptr=(char**)malloc(1);
  int number=strtol(Token->c_str(),endptr,10);
  if (!IsNumeric(Token)) throw ERR_CAST_NON_NUMERIC;
*/
	  if (Token==""||Token==" ") return 0;

	  float number;
	  std::istringstream ss(Token);
	  ss >> number;
	  return number;
       }

   static
     string
     GetString(float aNumber)
       {
	  std::ostringstream ss;
	  ss << aNumber;
	  return ss.str();
       }

   static
     string
     GetStringInt(int aNumber)
       {
	  std::ostringstream ss;
	  ss << (aNumber);
	  return ss.str();
       }

   static
     bool
     IsTag(std::string *Token)
       {
	  std::string symbol("<");
	  std::string symbol2(">");

	  if ((Token->substr(0,1)==symbol)&&(Token->substr(Token->length()-1,1)==symbol2))
	    return true;
	  return false;
       }

   static
     bool
     IsCloseTag(std::string *Token)
       {
	  std::string symbol3("/");

	  if (Token->substr(1,1)==symbol3)
	    return true;
	  return false;
       }

   static
     std::string
     GetNextToken(std::ifstream *Datafile)
       {
	  // if (Datafile.eof()) throw ERR_END_OF_FILE
	  //  std::string *Token=new std::string();
	  std::string Token;
	  *Datafile >> Token;
	  return Token;
       }

   static
     std::string
     GetStringUntilSep(std::string aString,string aSeparator)
       {
	  return aString.substr(0,GetTokenDivider(aString,aSeparator));
       }

   static
     std::string
     GetStringFromSep(std::string aString,string aSeparator)
       {
	  //+1 to skip the separator
	  return aString.substr(GetTokenDivider(aString,aSeparator)+1,aString.length());
       }

   static
     std::string
     GetSubToken(std::string aFather,int aWhere)
       {

	  std::string Father=TrimToken(aFather);

	  if (Father=="") return "";

	  if (aWhere==0)
	    return Father.substr(0,GetTokenDivider(Father," "));
	  else
	    {
	       //if (GetTokenDivider(Father," ")==strlen(Father.c_str()))  return "";
	       return GetSubToken(Father.substr(GetTokenDivider(Father," "),Father.length()),aWhere-1);
	    }
       }

/*
static
std::string
GetSubToken(std::string aFather,int aWhere)
{

  std::string *tmp=TrimToken(&aFather);
  std::string Father=*tmp;
  //delete tmp;

  if (Father=="") return "";

  if (aWhere==0)
    	return Father.substr(0,GetTokenDivider(Father," "));
    else
    {
      	//if (GetTokenDivider(Father," ")==strlen(Father.c_str()))  return "";
      	return GetSubToken(Father.substr(GetTokenDivider(Father," "),Father.length()),aWhere-1);
    }
}
*/

   static
     std::string
     TrimToken(std::string Father)
       {
	  if (((Father)!="")&&((Father)!=" "))
	    {
	       int pos1=0;
	       int pos2=Father.length();
	       while ((Father.substr(pos1,1)==" ")&&(pos1!=(Father.length()))) pos1++;
	       while ((Father.substr(pos2,1)==" ")&&(pos2!=pos1)) pos2--;
	       return Father.substr(pos1,pos2-pos1); //mexi nisso...e deu certo  delete newstring;
	    }
	  else
	    return "";

       }

   static
     std::string
     GetTagName(std::string &Father)
       {
	  Uint16 pos1=1;
	  Uint16 pos2=Father.length()-2;
	  if (IsCloseTag(&Father)) pos1=2;
	  return Father.substr(pos1,pos2-pos1+1);
       }

};

#endif
