#include "Cube.h"
#include <GL/glut.h>
#include <stdio.h>

Cube::Cube()
{
   Object();
}

void Cube::Make()
{
   glPushMatrix();
   glTranslatef(iPosition.x,iPosition.y,iPosition.z);
   glRotatef(iRotate.x,1.0,0.0f,0.0f);
   glRotatef(iRotate.y,0.0,1.0f,0.0f);
   glRotatef(iRotate.z,0.0,0.0f,1.0f);
   glutSolidCube(iSize.x);
   glPopMatrix();
}

void Cube::Update()
{
   const dReal *p,*r;
  
   UpdateDisableState();
   
   if(dBodyIsEnabled(iBody) == 0)
     return;
   
   p = dBodyGetPosition(iBody);
   iPosition.x = p[0];
   iPosition.y = p[1];
   iPosition.z = p[2];
   r = dGeomGetRotation(iGeom);
   iRotate.x = p[0];
   iRotate.y = p[1];
   iRotate.z = p[2];
};
