#include "BZK_ParsingTools.h"
#include "Mesh.h"
#include <GL/gl.h>

using namespace std;

Mesh::Mesh()
{
   iSize.x = iSize.y = iSize.z = 1;
   iPosition.x = iPosition.y = iPosition.z = 0;
   iVel.x = iVel.y =iVel.z = 0;
//   dMassSetZero(&iMass);
   iM = 1;                      
}

Mesh::Mesh(string filename)
{
   Mesh();                         
}
void Mesh::load(string filename)
{
     string echo;
     ifstream datafile;
     numVecs=0;
     numTrigs=0;
     numIndexs=0;
     int nVecs=0;
     int nIndexs=0;
     datafile.open(filename.c_str());
     if (datafile==NULL)
     {
     exit(0);
     }
     while(!datafile.eof())
     {
         echo=BZK_ParsingTools::GetNextToken(&datafile);
         
         if(echo=="v")
            numVecs++;
         
         if (echo=="f")
             numIndexs+=3;
     }
     
     datafile.clear();
     
     datafile.open(filename.c_str());
     ifstream data2;
     data2.open(filename.c_str());
     vecs=new dVector3[numVecs+1];
     indexs=new int[numIndexs+1];
     
     while(!data2.eof())
     {
         echo=BZK_ParsingTools::GetNextToken(&data2);
         if (echo=="v")
         {
             
             vecs[nVecs][0] = BZK_ParsingTools::GetNumber(BZK_ParsingTools::GetNextToken(&data2));
             vecs[nVecs][1] = BZK_ParsingTools::GetNumber(BZK_ParsingTools::GetNextToken(&data2));
             vecs[nVecs][2] = BZK_ParsingTools::GetNumber(BZK_ParsingTools::GetNextToken(&data2));
             nVecs++;
         }
         
         if (echo=="f")
         {
             
             indexs[nIndexs] =  (int)BZK_ParsingTools::GetNumber(BZK_ParsingTools::GetNextToken(&data2)) -1; 
             nIndexs++;
             indexs[nIndexs] =  (int)BZK_ParsingTools::GetNumber(BZK_ParsingTools::GetNextToken(&data2)) -1;
             nIndexs++;
             indexs[nIndexs] =  (int)BZK_ParsingTools::GetNumber(BZK_ParsingTools::GetNextToken(&data2)) -1 ;
             nIndexs++;
         }
             
     }
     datafile.clear();    
     std::cout << "Dados Lidos" << std::endl;
}


Mesh::~Mesh()
{
                       
}

void Mesh::MakeBody(dWorldID world)
{
     
}

void Mesh::MakeGeom(dSpaceID space)
{
     triData = dGeomTriMeshDataCreate();
     dGeomTriMeshDataBuildSimple(triData, (dReal*)vecs, numVecs, indexs, numIndexs);
     iGeom = dCreateTriMesh(space, triData,0,0,0);
     dGeomSetPosition(iGeom, iPosition.x, iPosition.y, iPosition.z);
}

void Mesh::Make()
{
  int i=0;
      glPushMatrix();
      glTranslatef(iPosition.x,iPosition.y,iPosition.z);
     glBegin(GL_TRIANGLES);
        for(i=0;i<numIndexs+1;i++)
        {
            glVertex3f(vecs[indexs[i]][0],vecs[indexs[i]][1],vecs[indexs[i]][2]);
        }
     glEnd();
     glPopMatrix();
}

void Mesh::Update()
{
     
};
