#ifndef __MESH__
#define __MESH__

#include "vec3d.h"
#include "Object.h"
#include <ode/ode.h>
#include <string>
#include <iostream>
    
class Mesh:public Object
{
      public:
             Mesh();
             Mesh(std::string filename);
             void load(std::string filename);
             virtual void MakeBody(dWorldID world);
             virtual void MakeGeom(dSpaceID space);
             virtual void Make();
             virtual void Update();
             
             ~Mesh();
      private:
              int numElements;
              dVector3 *vecs;
              dTriMeshDataID triData;
              int *indexs;
              int numVecs;
              int numTrigs;
              int numIndexs;            
};

#endif
