#ifndef __OBJECT_C__
#define __OBJECT_C__
#include <ode/ode.h>
#include "vec3d.h"
#include "definitions.h"

class Object
{
 public:
   Object();
   virtual void MakeBody(dWorldID world);
   virtual void MakeGeom(dSpaceID space);
   virtual void LinkBodyWithGeom();
   virtual void Update();
   virtual void UpdateDisableState();
   virtual void Make();
   vec3d iPosition;
   vec3d iSize;
   vec3d iRotate;
   vec3d iVel;
   float iM;
   float disabledSteps;
   dMass iMass;
   dBodyID iBody;
   dGeomID iGeom;
};
#endif  
