#include "Sphere.h"
#include <GL/glut.h>
#include <stdio.h>

Sphere::Sphere(float r,int slice,int stack)
{
   iRadius = r;
   iSlices = slice;
   iStacks = stack;  
}

void Sphere::MakeBody(dWorldID world)
{
   iBody = dBodyCreate(world);
   dMassSetSphereTotal(&iMass,iM,iRadius);
   dBodySetMass(iBody,&iMass);
   dBodySetPosition(iBody,iPosition.x,iPosition.y,iPosition.z);
   dBodySetLinearVel(iBody,iVel.x,iVel.y,iVel.z);
   disabledSteps = 0;
}

void Sphere::MakeGeom(dSpaceID space)
{
   iGeom = dCreateSphere(space,iRadius);
}

void Sphere::Make()
{
   glPushMatrix();
   glTranslatef(iPosition.x,iPosition.y,iPosition.z);
   glRotatef(iRotate.x,1.0,0.0f,0.0f);
   glRotatef(iRotate.y,0.0,1.0f,0.0f);
   glRotatef(iRotate.z,0.0,0.0f,1.0f);
   glutSolidSphere(iRadius,iSlices,iStacks);
   glPopMatrix();
}

void Sphere::Update()
{
   const dReal *p,*r;
   
   UpdateDisableState();
   
   if(dBodyIsEnabled(iBody) == 0)
     return;
   
   p = dBodyGetPosition(iBody);
   iPosition.x = p[0];
   iPosition.y = p[1];
   iPosition.z = p[2];
   r = dGeomGetRotation(iGeom);
   iRotate.x = p[0];
   iRotate.y = p[1];
   iRotate.z = p[2];
//   v = dBodyGetLinearVel(iBody);
//   dBodyAddForce(iBody,v[0]*v[0]+v[1]*v[1]+v[2]*v[2],0,0);
//   printf("x: %f, y: %f z: %f\n",p[0],p[1],p[2]);
};
