#ifndef __WORLD__
#define __WORLD__
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <SDL/SDL.h>
#include "vec3d.h"
#include "BZK_List.h"
#include "Space.h"
#include "SpaceManager.h"
using namespace std;

class World
{
 public:
   World(string aWorld);
   SpaceManager *iSpaces;
   dWorldID world;
   dJointGroupID contactGroup;
   dSpaceID topLevelSpace;
   void Update();
   void Draw();
   
 private:
   string space;
   string endSpace;
   string name;
   string endName;
   string Echo;
   string cube;
   string endCube;
   string sphere;
   string endSphere;
   string size;
   string endSize;
   string position;
   string endPosition;
   string mass;
   string endMass;
   string rotation;
   string endRotation;
   string linearVel;
   string endLinearVel;
   string angularVel;
   string endAngularVel;
   string vec;
   string endVec;
   string type;
   string endType;
   string mesh;
   string endMesh;
   string path;
   string endPath;
   ifstream Datafile;
   Space *currentSpace;
   float stepSize;
   void getObjectDetails();
   void getSpace();
   void getCube();
   void getMesh();
   vec3d getVec();
   void NextObjectProperty(Object *obj);

};
#endif
